Complexity:
Is Regression: No
Sprint Focus:
Subject: Calculated absolute path to tslib directory does not exist.
Description

I started a fresh empty installation with TYPO3 6.2.5. The installation has been done automatically based on the file FIRST_INSTALL.

The Frontend only shows:

*Calculated absolute path to tslib directory does not exist.*

drwxrwsrwx  4 www-data www-data 4096 Okt  7 11:37 fileadmin
lrwxrwxrwx  1 user  user    15 Okt  7 10:33 index.php -> typo3/index.php
lrwxrwxrwx  1 user  user    15 Okt  6 22:05 typo3 -> typo3_src/typo3
drwxrwsr-x  4 www-data www-data 4096 Okt  7 11:10 typo3conf
lrwxrwxrwx  1 user  user    15 Okt  6 22:04 typo3_src -> typo3_src-6.2.5
drwxrwxrwx  3 user  user  4096 Sep 23 15:33 typo3_src-6.2.5
drwxrwsr-x 13 www-data www-data 4096 Okt  7 11:37 typo3temp
drwxrwsr-x  5 www-data www-data 4096 Okt  7 11:07 uploads
root@Server-Ubuntu-64 /home/user/public_html/typo3 # pwd
/home/user/public_html/typo3

The new site has the example setup:

# Default PAGE object:
page = PAGE
page.10 = TEXT
page.10.value = HELLO WORLD!

I did not install any extensions by myself. Only the first installation process did install them.

Related issues:
related to Core - Feature # 62089: error message: Wrong symbolic link to inde... Resolved 2014-10-07

History
#1 - 2014-10-07 12:40 - Markus Klein

Can you please try to move the "typo3_src-6.2.5" one level up and tell us, if this changes something?

2015-08-04 1/8



#2 - 2014-10-07 13:29 - Franz Holzinger

I have moved the TYPO3 source a directory level up:

root@Server-Ubuntu-64 /home/user/public_html/typo3 # mv typo3_src-6.2.5 ..
root@Server-Ubuntu-64 /home/user/public_html/typo3 # rm typo3_src
root@Server-Ubuntu-64 /home/user/public_html/typo3 # ln -s ../typo3_src-6.2.5 typo3_src

root@Server-Ubuntu-64 /home/user/public_html/typo3 # ls -l
total 16
drwxrwsrwx  4 www-data www-data 4096 Okt  7 11:44 fileadmin
lrwxrwxrwx  1 user  user    15 Okt  7 10:33 index.php -> typo3/index.php
lrwxrwxrwx  1 user  user    15 Okt  6 22:05 typo3 -> typo3_src/typo3
drwxrwsr-x  4 www-data www-data 4096 Okt  7 11:10 typo3conf
lrwxrwxrwx  1 user  user    18 Okt  7 13:25 typo3_src -> ../typo3_src-6.2.5
drwxrwsr-x 13 www-data www-data 4096 Okt  7 11:37 typo3temp
drwxrwsr-x  5 www-data www-data 4096 Okt  7 11:07 uploads

Still the same error.

#3 - 2014-10-07 14:43 - Markus Klein

alright, then you need some debugging what is wrong with your environment.

typo3/sysext/core/Classes/Core/SystemEnvironmentBuilder.php
method definePaths()

at the end add:
die(PATH_site . ';' . TYPO3_mainDir);

#4 - 2014-10-07 14:58 - Franz Holzinger

The result is:

/home/user/public_html/;typo3/

ls -l /home/user/public_html/typo3/typo3/sysext/core/Classes/Core/SystemEnvironmentBuilder.php
-rwxrwxrwx 1 user user 19937 Okt  7 14:56 /home/user/public_html/typo3/typo3/sysext/core/Classes/Core/SystemEnvironmentBuilder.php

The TYPO3 root should be here:

/home/user/public_html/typo3/

2015-08-04 2/8



#5 - 2014-10-07 15:28 - Markus Klein

So PATH_site is wrong, what do you have for PATH_thisScript?

#6 - 2014-10-07 15:58 - Alexander Opitz

As written in #53037 you seam to have a broken linkages.

lrwxrwxrwx  1 user  user    15 Okt  7 10:33 index.php -> typo3/index.php

The index.php should link to typo3_src/index.php

#7 - 2014-10-07 16:00 - Alexander Opitz

ls from my test system:

drwxrws--- 10 www-data www-data  4096 Sep 26 09:51 fileadmin
lrwxrwxrwx  1 opitz    www-data    19 Okt 14  2013 index.php -> typo3_src/index.php
lrwxrwxrwx  1 opitz    www-data    15 Okt 14  2013 typo3 -> typo3_src/typo3
drwxrws---  5 opitz    www-data  4096 Sep 26 09:51 typo3conf
drwxrwxr-x  4 opitz    www-data  4096 Okt  6 17:22 typo3-src
drwxrws--- 16 opitz    www-data 28672 Sep 26 09:51 typo3temp

#8 - 2014-10-07 16:00 - Franz Holzinger

I get this:

PATH_thisScript: /home/user/public_html/typo3/index.php

Yes, the link to index.php is wrong.

index.php -> typo3/index.php

instead of

index.php -> typo3_src/index.php

After changing this, I get:

 HELLO WORLD! 

The error message should point out this information:
Wrong symbolic link to index.php.
#9 - 2014-10-07 16:59 - Michael Stucki

That's not a bug, you just set the symlink wrong. Please close the issue. If you like to throw a warning in such a case, consider it as a new feature.

#10 - 2014-10-07 17:09 - Alexander Opitz
- Status changed from New to Closed

We can't know what the issue is behind the scene so no other error message IMHO => closed.

#11 - 2014-10-08 00:25 - Markus Klein

See #62089 for a possible solution.

#12 - 2015-02-02 16:34 - Alfred Bez

I have the same error message, but only when I run 

php typo3/cli_dispatch.phpsh whatever

ls:

drwxr-xr-x 10 p123456789 users 4096  2. Feb 15:33 fileadmin
lrwxrwxrwx  1 p123456789 users   19 24. Nov 13:50 index.php -> typo3_src/index.php
lrwxrwxrwx  1 p123456789 users   15 24. Nov 13:50 typo3 -> typo3_src/typo3
drwxr-xr-x  4 p123456789 users 4096  2. Feb 15:33 typo3conf
lrwxrwxrwx  1 p123456789 users   15 10. Dez 17:21 typo3_src -> typo3_src-6.2.9
drwxr-xr-x  3 p123456789 users 4096 28. Jan 22:03 typo3_src-6.2.9
drwxr-xr-x 15 p123456789 users 4096  2. Feb 15:33 typo3temp
drwxr-xr-x 12 p123456789 users 4096  2. Feb 15:33 uploads

Error message:

php typo3/cli_dispatch.phpsh crawler
X-Powered-By: PHP/5.5.18
Content-type: text/plain

Calculated absolute path to tslib directory does not exist.

Something in the main file, folder and link structure is wrong and must be fixed! A typical document root contains a couple of symbolic links:
* A symlink "typo3_src" pointing to the TYPO3 CMS core.
* A symlink "typo3" - the backend entry point - pointing to "typo3_src/typo3" 
* A symlink "index.php" - the frontend entry point - points to "typo3_src/index.php" 
It's a project with one website (3 languages and more than 130 Pages), TYPO3 v6.2.9.

#13 - 2015-02-02 17:22 - Alexander Opitz

Hi Alfred,

and the directory typo3_src-6.2.9 is a clean checkout? Or did you symlink something else in it?
Can you post the response of ls inside this directory?

Is it a new install or an update and it worked before?

#14 - 2015-02-03 08:56 - Alfred Bez

Hi Alexander,

ls:

insgesamt 1568
drwxr-xr-x 3 p123456789 users    4096 28. Jan 22:03 ./
drwxr-xr-x 9 p123456789 users    4096  2. Feb 17:00 ../
-rw-r--r-- 1 p123456789 users 1512722 10. Dez 11:45 ChangeLog
-rw-r--r-- 1 p123456789 users    3816 10. Dez 11:45 composer.json
-rw-r--r-- 1 p123456789 users     691 10. Dez 11:45 .editorconfig
-rw-r--r-- 1 p123456789 users    5472 10. Dez 11:45 _.htaccess
-rw-r--r-- 1 p123456789 users     921 10. Dez 11:45 index.php
-rw-r--r-- 1 p123456789 users    9479 10. Dez 11:45 INSTALL.md
-rw-r--r-- 1 p123456789 users   18425 10. Dez 11:45 LICENSE.txt
-rw-r--r-- 1 p123456789 users    9420 10. Dez 11:45 NEWS.md
-rw-r--r-- 1 p123456789 users    5578 10. Dez 11:45 README.md
drwxr-xr-x 9 p123456789 users    4096  2. Feb 16:14 typo3/
p123456789:/home/www/p123456789/html/typo3/typo3_src-6.2.9 >

It is a new install.

#15 - 2015-02-03 10:02 - Markus Klein

@Alfred: Please check if your PHP configuration for CLI differs from the WEB configuration somehow.

#16 - 2015-02-03 10:03 - Alexander Opitz

Hi Alfred,

hmmm looks ok so far. So something else must happen.

Can you please edit a file:

/typo3/sysext/core/Classes/Core/SystemEnvironmentBuilder.php
Around line 184 should be something like:

if (!is_dir(PATH_tslib)) {
    static::dieWithMessage('Calculated absolute path to tslib directory does not exist.' . LF . LF
        . 'Something in the main file, folder and link structure is wrong and must be fixed! A typical document root contains a couple of symbolic
links:' . LF
        . '* A symlink "typo3_src" pointing to the TYPO3 CMS core.' . LF
        . '* A symlink "typo3" - the backend entry point - pointing to "typo3_src/typo3"' . LF
        . '* A symlink "index.php" - the frontend entry point - points to "typo3_src/index.php"');
}

can you please add before static::dieWithMessage following:

var_dump(PATH_thisScript, PATH_site);

Then you will see, witch path TYPO3 thinks he is in?

#17 - 2015-02-03 10:07 - Alfred Bez

@Alexander

string(18) "/usr/local/bin/php" 
string(9) "/usr/loca" 

#18 - 2015-02-03 12:20 - Alexander Opitz

Oh, that's very false.
What does

php -v

outputs?

And does it work by running the command like

./typo3/cli_dispatch.phpsh bla

(Without the "php" on command line.)

#19 - 2015-02-03 12:57 - Alfred Bez

~ > php -v
PHP 5.5.18 (cgi-fcgi) (built: Oct 24 2014 11:13:40)
Copyright (c) 1997-2014 The PHP Group
Zend Engine v2.5.0, Copyright (c) 1998-2014 Zend Technologies

p123456789:/home/www/p123456789/html/typo3 > ./typo3/cli_dispatch.phpsh bla
This script must have a 'cliKey' as first argument. Valid keys are:

  extbase
  lowlevel_admin
  lowlevel_cleaner
  lowlevel_refindex
  scheduler

X-Powered-By: PHP/5.5.18
Content-type: text/html

There is no difference when I change bla to scheduler...

#20 - 2015-02-03 13:20 - Alexander Opitz

So you are using the php for cgi and not cli. Du you have an executable called php5-cli?

If not, what system are you running? Is the PHP self compiled or installed from a package?

#21 - 2015-02-05 11:05 - Alfred Bez

I have an executable called php_cli

p123456789:/usr/local/bin > l php*
lrwxrwxrwx 1 mw mw 14 24. Nov 13:46 php -> ../php/bin/php*
lrwxrwxrwx 1 mw mw 18 24. Nov 13:46 php_cli -> ../php/bin/php_cli*

#22 - 2015-02-05 11:09 - Alexander Opitz

And what does php_cli -v response? Does php_cli ./typo3/cli_dispatch.phpsh scheduler works?

#23 - 2015-02-05 11:23 - Alfred Bez

p123456789:~ > php_cli -v
PHP 5.5.18 (cli) (built: Oct 24 2014 11:13:29)
Copyright (c) 1997-2014 The PHP Group
Zend Engine v2.5.0, Copyright (c) 1998-2014 Zend Technologies
p123456789:~ > php -v
PHP 5.5.18 (cgi-fcgi) (built: Oct 24 2014 11:13:40)
Copyright (c) 1997-2014 The PHP Group
Zend Engine v2.5.0, Copyright (c) 1998-2014 Zend Technologies
Looks like php_cli ./typo3/cli_dispatch.phpsh scheduler works:

p123456789:/home/www/p123456789/html/typo3 > php_cli ./typo3/cli_dispatch.phpsh scheduler
p123456789:/home/www/p123456789/html/typo3 >

#24 - 2015-02-05 13:57 - Alexander Opitz

Fine if this works. :-)

#25 - 2015-02-05 14:25 - Alfred Bez

thanks for your help
